pragma Singleton
import QtQuick 2.12
import QtQml 2.12
import com.kylin.tablet 1.0

QtObject {
    id: controller
    property bool groupPopuped: false
    property int popupedGroupId: -1
    property bool aboutToInsertGroup: false
    property var underItem: undefined
    property var aboveItem: undefined
    property int underItemId: -1
    property int newGroupId: -1

    function popupGroup(appIcon, scrollToLast) {
        if (groupPopuped) {
            return
        }
        if (appIcon.type === LauncherItem.AppIcon) {
            var groupId = modelManager.createPopupGroupModel(appIcon.itemId, aboveItem.itemId, true)
            if (groupId === -1) {
                console.warn("Create group failed!", appIcon.itemId)
                return
            }
            newGroupId = groupId
        } else {
            modelManager.popupGroup(appIcon.itemId)
            if (scrollToLast) {
                appIcon.pageContainer.pageContainer.currentIndex = appIcon.pageContainer.pageContainer.count - 1
            }
        }
        groupPopuped = true
        popupedGroupId = appIcon.itemId
    }

    function minimizeGroup() {
        if (!groupPopuped) {
            return
        }
        modelManager.minimizeGroup(popupedGroupId)
        groupPopuped = false
        popupedGroupId = -1
        aboutToInsertGroup = false
    }

    function aboutToInsertItemToGroup(underItem, aboveItem) {
        modelManager.setItemState(LauncherItem.Under, underItem.itemId)
        aboutToInsertGroup = true
        controller.underItem = underItem
        underItemId = underItem.itemId
        controller.aboveItem = aboveItem
    }

    function canceInsertToGroup() {
        aboutToInsertGroup = false
    }

    function insertItemToGroup(itemIndex, pageIndex, aboveItemId, appIcon, appName) {
        if (groupPopuped) {         
            modelManager.moveItemToGroup(itemIndex, pageIndex, popupedGroupId)
        } else if (aboutToInsertGroup) {
            appIcon.visible = false
            appName.visible = false
            if (underItem.type !== LauncherItem.Group) {
                var groupId = modelManager.createPopupGroupModel(underItemId, aboveItemId, false)
                modelManager.setGroupState(LauncherItem.Editable, groupId)
                newGroupId = groupId
            } else {
                modelManager.moveItemToGroup(itemIndex, pageIndex, underItemId)
                modelManager.setGroupState(LauncherItem.Editable, underItemId)
            }
            aboutToInsertGroup = false
        }
    }
}
